Index: /trunk/contactcenter/inc/class.ui_data.inc.php
===================================================================
--- /trunk/contactcenter/inc/class.ui_data.inc.php	(revision 276)
+++ /trunk/contactcenter/inc/class.ui_data.inc.php	(revision 284)
@@ -14,5 +14,5 @@
   \***************************************************************************/
 
-	
+
 	class ui_data
 	{
@@ -20,8 +20,8 @@
 			'data_manager' => true,
 		);
-		
+
 		var $bo;
 		var $typeContact;
-		
+
 		var $page_info = array(
 			'n_cards'          => 20,
@@ -34,12 +34,12 @@
 			'actual_catalog'   => false
 		);
-		
+
 		/*!
-		
+
 			@function ui_data
 			@abstract The constructor. Sets the initial parameters and loads
 				the data saved in the session
 			@author Raphael Derosso Pereira
-			
+
 		*/
 		function ui_data()
@@ -47,7 +47,11 @@
 			$temp = $GLOBALS['phpgw']->session->appsession('ui_data.page_info','contactcenter');
 			$temp2 = $GLOBALS['phpgw']->session->appsession('ui_data.all_entries','contactcenter');
-			
+
+			//TODO: Achar um modo de descarregar este array da sessï¿œo quando o usuï¿œrio sair da tela do contactcenter.
+			//TODO: Descarregar este array da memï¿œria toda vez que uma nova consulta por letras ou mudanï¿œa de catï¿œlogo for feita.
+			$temp3 = $GLOBALS['phpgw']->session->appsession('ui_data.last_search_ids','contactcenter');
+
 			$this->bo = CreateObject('contactcenter.bo_contactcenter');
-			
+
 			if ($temp)
 			{
@@ -59,5 +63,10 @@
 				$this->all_entries = $temp2;
 			}
-			
+
+			if ($temp3)
+			{
+				$this->last_search_ids = $temp3;
+			}
+
 			if (!$this->page_info['actual_catalog'])
 			{
@@ -65,7 +74,7 @@
 				$this->page_info['actual_catalog'] = $catalogs[0];
 			}
-			
-			$this->page_info['actual_catalog'] =& $this->bo->set_catalog($this->page_info['actual_catalog']);			
-			
+
+			$this->page_info['actual_catalog'] =& $this->bo->set_catalog($this->page_info['actual_catalog']);
+
 			if($this->page_info['actual_catalog']['class'] == 'bo_group_manager')
 				$this -> typeContact = 'groups';
@@ -75,13 +84,13 @@
 
 		/*!
-		
+
 			@function index
 			@abstract Builds the Main Page
 			@author Raphael Derosso Pereira
 			@author Jonas Goes
-			
-		*/		
+
+		*/
 		function index()
-		{	
+		{
 			if(!@is_object($GLOBALS['phpgw']->js))
 			{
@@ -92,11 +101,11 @@
 			$GLOBALS['phpgw']->js->validate_file('venus','jsStructUtil');
 			$GLOBALS['phpgw']->js->validate_file('venus','cssUtil');
-			
+
 //			$GLOBALS['phpgw']->js->set_onload('setTimeout(\'updateCards()\',1000)');
 			$GLOBALS['phpgw']->common->phpgw_header();
-			
+
 			$GLOBALS['phpgw']->template->set_file(array('index' => 'index.tpl'));
 			$GLOBALS['phpgw']->template->set_var('cc_root_dir', $GLOBALS['phpgw_info']['server']['webserver_url'].'/contactcenter/');
-			
+
 			/* Quick Add */
 			$GLOBALS['phpgw']->template->set_var('cc_qa_alias',lang('Alias').':');
@@ -107,7 +116,6 @@
 			$GLOBALS['phpgw']->template->set_var('cc_qa_save',lang('Save'));
 			$GLOBALS['phpgw']->template->set_var('cc_qa_clear',lang('Clear'));
-			$GLOBALS['phpgw']->template->set_var('cc_qa_close',lang('Close'));
 			/* End Quick Add */
-			
+
 			$cc_css_file = $GLOBALS['phpgw_info']['server']['webserver_url'].'/contactcenter/styles/cc.css';
 			$cc_card_image_file = $GLOBALS['phpgw_info']['server']['webserver_url'].'/contactcenter/templates/default/images/card.png';
@@ -115,10 +123,10 @@
 			$GLOBALS['phpgw']->template->set_var('cc_dtree_css', $cc_dtree_file);
 			$GLOBALS['phpgw']->template->set_var('cc_card_image',$cc_card_image_file);
-			
+
 			$GLOBALS['phpgw']->template->set_var('cc_personal',lang('Personal'));
-			
+
 			$GLOBALS['phpgw']->template->set_var('cc_full_add',lang('Full Add'));
 			$GLOBALS['phpgw']->template->set_var('cc_reset',lang('Reset'));
-			
+
 			$GLOBALS['phpgw']->template->set_var('cc_personal_data',lang('Personal Data'));
 			$GLOBALS['phpgw']->template->set_var('cc_addresses',lang('Addresses'));
@@ -129,5 +137,5 @@
 			$GLOBALS['phpgw']->template->set_var('cc_catalogs',lang('Catalogues'));
 			$GLOBALS['phpgw']->template->set_var('cc_group_add',lang('Group Add'));
-			
+
 			/* Panel */
 			$GLOBALS['phpgw']->template->set_var('cc_panel_new',lang('New').'...');
@@ -135,7 +143,5 @@
 			$GLOBALS['phpgw']->template->set_var('cc_panel_table',lang('Table View'));
 			$GLOBALS['phpgw']->template->set_var('cc_panel_cards',lang('Cards View'));
-			$GLOBALS['phpgw']->template->set_var('cc_btn_import_export', lang('Import/Export'));
-			$GLOBALS['phpgw']->template->set_var('cc_btn_new', lang("New..."));
-			
+
 			$GLOBALS['phpgw']->template->set_var('cc_panel_search_found',lang('Showing found entries'));
 			$GLOBALS['phpgw']->template->set_var('cc_panel_first_page',lang('First Page'));
@@ -145,5 +151,5 @@
 			$GLOBALS['phpgw']->template->set_var('cc_all',lang('all'));
 			/* End Panel */
-			
+
 			/* Messages */
 			$GLOBALS['phpgw']->template->set_var('cc_msg_no_cards',lang('No Cards'));
@@ -160,11 +166,10 @@
 			$GLOBALS['phpgw']->template->set_var('cc_empty',lang('Empty'));
 			/* End Messages */
-			
+
 			$GLOBALS['phpgw']->template->set_var('cc_results',lang('Results'));
 			$GLOBALS['phpgw']->template->set_var('cc_is_my',lang('Is My'));
-			$GLOBALS['phpgw']->template->set_var('cc_ie_personal',lang('Import/Export pesonal contacts'));
 			$GLOBALS['phpgw']->template->set_var('cc_btn_search',lang('Search'));
 			$GLOBALS['phpgw']->template->set_var('cc_add_relation',lang('Add Relation'));
-			$GLOBALS['phpgw']->template->set_var('cc_del_relation',lang('Remove Selected Relations'));			
+			$GLOBALS['phpgw']->template->set_var('cc_del_relation',lang('Remove Selected Relations'));
 			$GLOBALS['phpgw']->template->set_var('cc_msg_group',lang('Group'));
 			$GLOBALS['phpgw']->template->set_var('cc_msg_contact_full',lang('Contact [Full]'));
@@ -174,55 +179,6 @@
 			$GLOBALS['phpgw']->template->set_var('phpgw_img_dir', $GLOBALS['phpgw_info']['server']['webserver_url'] . '/phpgwapi/images');
 
-			$GLOBALS['phpgw']->template->set_var('cc_msg_import_contacts', lang('Import Contacts'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_export_contacts', lang('Export Contacts'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_expresso_info_csv', lang('The Expresso supports the contacts importation in the CSV file format.'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_choose_file_type', lang('Select the file type'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_outlook_express', lang('Outlook Express'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_outlook2k', lang('Outlook 2000'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_expresso_default', lang('Expresso (default)'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_choose_contacts_file', lang('Select the file that contains the contacts to be imported:'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_close_win', lang('Close'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_ie_personal', lang('Import / Export personal Contacts'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_import_fail', lang('The importation has failed. Verify the file format.'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_importing_contacts', lang('Importing Contacts...'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_import_finished', lang('The importation has finished.'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_new', lang(' new'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_failure', lang(' failed'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_exists', lang(' were existent'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_show_more_info', lang('show more info'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_clean', lang('Clean'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_invalid_csv', lang('Select a valid CSV file to import your contacts'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_export_csv', lang('Select the format type that you want to export your contacts'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_automatic', lang('Automatic'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_export_error', lang('An error has occurred while the exportation.'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_new_email', lang('New Email'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_main', lang('Main'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_alternative', lang('Alternative'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_select_email', lang('Select E-Mail'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_new_phone', lang('New Telephone'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_home', lang('Home'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_cellphone', lang('Cellphone'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_work', lang('Work'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_fax', lang('Fax'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_pager', lang('Pager'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_choose_phone', lang('Select the telephone'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_warn_firefox', lang('Warning: Too old version of Firefox'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_firefox_half1', lang('For this application work correctly</u>'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_firefox_half2', lang('it\'s necessary to update your Firefox Browser for a new version (version > 1.5) Install now clicking in the link bellow, or if you want to update it later'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_click_close', lang('click Close'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_install_now', lang('Install Now'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_install_new_firefox', lang('Install a new Firefox version'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_moz_thunderbird', lang('Export as Mozilla Thunderbird CSV.'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_outlook_express_pt', lang('Export as Outlook Express (Portuguese) CSV.'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_outlook_express_en', lang('Export as Outlook Express (English) CSV.'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_outlook_2k_pt', lang('Export as Outlook 2000 (Portuguese) CSV.'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_outlook_2k_en', lang('Export as Outlook 2000 (English) CSV.'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_expresso_default_csv', lang('Export as Expresso (Default) CSV.'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_copy_to_catalog', lang('Copy to personal catalog.'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_add_contact_to_group', lang('You did not add any contact for this group.'));
-			$GLOBALS['phpgw']->template->set_var('cc_msg_fill_field_name', lang('Fill the field Full Name'));
-			
 			$GLOBALS['phpgw']->template->parse('out','index');
-			
+
 			$api = CreateObject('contactcenter.ui_api');
 			$main = $api->get_full_add();
@@ -235,12 +191,12 @@
 		}
 
-		
+
 		/*!
-		
+
 			@function data_manager
-			@abstract Calls the right method and passes to it the right 
+			@abstract Calls the right method and passes to it the right
 				parameters
 			@author Raphael Derosso Pereira
-		
+
 		*/
 		function data_manager()
@@ -251,7 +207,19 @@
 				case 'set_n_cards':
 					return $this->set_n_cards((int)$_GET['ncards']);
-					
+
 				case 'get_cards_data':
-					return $this->get_cards_data($_POST['letter'], $_POST['page'], unserialize(str_replace('\\"','"',$_POST['ids'])));
+
+					$ids = false;
+					// To support ldap catalogs using accentuation
+					if ($_POST['letter'] == 'search' && isset($_POST['data']))
+					{
+						//$ids = utf8_decode($this->search($_POST['data']));
+						$ids = $this->search($_POST['data']);
+					}
+
+					//return $this->get_cards_data($_POST['letter'], $_POST['page'], unserialize(str_replace('\\"','"',$ids)));
+					return $this->get_cards_data($_POST['letter'], $_POST['page'], $ids);
+					//return $this->get_cards_data($_POST['letter'], $_POST['page'], unserialize(str_replace('\\"','"',$_POST['ids'])));
+
 				case 'get_cards_data_get':
 					return $this->get_cards_data($_GET['letter'], $_GET['page'], unserialize(str_replace('\\"','"',$_GET['ids'])));
@@ -261,9 +229,9 @@
 					return $this->get_photo($_GET['id']);
 
-					
+
 				/* Catalog Methods */
 				case 'set_catalog':
 					return $this->set_catalog($_GET['catalog']);
-					
+
 				case 'get_catalog_tree':
 					echo serialize($this->get_catalog_tree($_GET['level']));
@@ -279,14 +247,15 @@
 
 				case 'get_catalog_add_contact':
-					echo serialize($this->get_catalog_add_contact($_POST['id']));
+					// To support ldap catalogs with accentuation
+					echo serialize($this->get_catalog_add_contact(utf8_decode($_POST['id'])));
 					return;
-					
+
 				/* Full Add Methods */
 				case 'get_full_data':
 					return $this->get_full_data($_GET['id']);
-				
+
 				case 'get_group':
 					return $this->get_group_data($_GET['id']);
-					
+
 				case 'get_contact_full_add_const':
 					return $this->get_contact_full_add_const();
@@ -300,25 +269,25 @@
 				case 'get_states':
 					return $this->get_states($_GET['country']);
-					
+
 				case 'get_cities':
 					return $this->get_cities($_GET['country'], $_GET['state'] ? $_GET['state'] : null);
-					
-					
+
+
 				/* Other Methods */
-				case 'quick_add':															
+				case 'quick_add':
 					return $this->quick_add($_POST['add']);
-				
-				case 'add_group':															
+
+				case 'add_group':
 					return $this->add_group($_POST['add']);
-									
+
 				case 'remove_entry':
 					return $this->remove_entry((int)$_GET['remove']);
-				
+
 				case 'remove_all_entries':
 					return $this->remove_all_entries();
 
 				case 'remove_group':
-					 					
-					return $this->remove_group((int)$_GET['remove']);					
+
+					return $this->remove_group((int)$_GET['remove']);
 
 				case 'search':
@@ -357,11 +326,11 @@
 
 		/*!
-		
+
 			@function set_n_cards
 			@abstract Informs the class the number of cards the page can show
 			@author Raphael Derosso Pereira
-			
+
 			@param integer $n_cards The number of cards
-			
+
 		*/
 		function set_n_cards($n_cards)
@@ -372,17 +341,17 @@
 				echo 1;
 			}
-			
+
 			$this->save_session();
 		}
-				
+
 		/*!
-		
+
 			@function set_catalog
 			@abstract Sets the current catalog selected by the user
 			@author Raphael Derosso Pereira
-			
+
 			@param string $id_catalog The sequence of IDs to reach the catalog
 				separated by commas
-		
+
 		*/
 		function set_catalog($id_catalog)
@@ -390,5 +359,5 @@
 			$id_catalog = str_replace('\\"', '"', $id_catalog);
 			$temp =& $this->bo->set_catalog($id_catalog);
-			
+
 			if ($temp)
 			{
@@ -397,7 +366,7 @@
 				$this->page_info['actual_catalog'] =& $temp;
 				$this->save_session();
-				
+
 				$catalog_info = $this->bo->get_branch_by_level($this->bo->catalog_level[0]);
-				
+
 				if ($catalog_info['class'] === 'bo_global_ldap_catalog' ||
 				    $catalog_info['class'] === 'bo_catalog_group_catalog')
@@ -409,5 +378,5 @@
 					$perms = 15;
 				}
-				
+
 				echo serialize(array(
 					'status' => 'ok',
@@ -417,5 +386,5 @@
 				return;
 			}
-			
+
 			echo serialize(array(
 				'status' => 'ok',
@@ -423,15 +392,16 @@
 			));
 		}
-		
-		
+
+
 		/*!
-		
+
 			@function get_catalog_tree
 			@abstract Returns the JS serialized array to used as the tree
 				level
 			@author Raphael Derosso Pereira
-			
-			@param (string) $level The level to be taken 
-		
+			@author Mï¿œrio Cï¿œsar Kolling (error messages and timeout)
+
+			@param (string) $level The level to be taken
+
 		*/
 		function get_catalog_tree($level)
@@ -442,5 +412,5 @@
 
 				$parent = '0';
-				
+
 				if (!($tree = $this->bo->get_catalog_tree($level)))
 				{
@@ -456,5 +426,5 @@
 				$parent = substr($level, 0, $last_dot);
 				$child = substr($level, $last_dot+1, strlen($level));
-			
+
 				if (!($tree[$child] = $this->bo->get_catalog_tree($level)))
 				{
@@ -464,18 +434,48 @@
 					);
 				}
-			}
-			
+				// Deals with timeout and returns the generated message to the browser
+				else if (!empty($tree[$child]['timeout']) && !empty($tree[$child]['msg']))
+				{
+					$tmp = array(
+						'msg'    => $tree[$child]['msg'],
+						'status' => 'fatal'
+					);
+					unset($tree[$child]);
+					return $tmp;
+				}
+			}
+
 			$folderImageDir = $GLOBALS['phpgw']->common->image('contactcenter','globalcatalog-mini.png');
 			$folderImageDir = substr($folderImageDir, 0, strpos($folderImageDir, 'globalcatalog-mini.png'));
-			
+
+			// Deals with error messages from the server and returns them to the browser
+			if ($tree['msg'])
+			{
+				$msg = $tree['msg'];
+				unset($tree['msg']);
+			}
+
 			$tree_js = $this->convert_tree($tree, $folderImageDir, $parent);
-			
-			return array(
-				'data' => $tree_js,
-				'msg'  => lang('Catalog Tree Successfully taken!'),
-				'status' => 'ok'
-			);
-		}
-		
+
+			// Return status = ok, or else return generated message to the browser
+			if (!$msg)
+			{
+				return array(
+					'data' => $tree_js,
+					'msg'  => lang('Catalog Tree Successfully taken!'),
+					'status' => 'ok'
+				);
+			}
+			else
+			{
+				return array(
+					'data' => $tree_js,
+					'msg'  => $msg,
+					'status' => 'error'
+				);
+
+			}
+		}
+
 /*		function get_catalog_tree($level, $name = 'tree')
 		{
@@ -487,5 +487,5 @@
 				$parent = '0';
 				$child  = '0';
-				
+
 				if (!($tree = $this->bo->get_catalog_tree($level)))
 				{
@@ -498,7 +498,7 @@
 				$parent = substr($level, 0, $last_dot);
 				$child = substr($level, $last_dot+1, strlen($level));
-			
+
 				$tree_js = '';
-				
+
 				if (!($tree[$child] = $this->bo->get_catalog_tree($level)))
 				{
@@ -506,16 +506,16 @@
 				}
 			}
-			
+
 			$folderImageDir = $GLOBALS['phpgw']->common->image('contactcenter','globalcatalog-mini.png');
 			$folderImageDir = substr($folderImageDir, 0, strpos($folderImageDir, 'globalcatalog-mini.png'));
-			
+
 			$tree_js .= $this->convert_tree($tree, $name, $folderImageDir, $parent);
-			
+
 			return $tree_js;
 		}
-*/		
-		
+*/
+
 		/*!
-		
+
 			@function get_actual_catalog
 			@abstract Returns the actual selected Catalog
@@ -524,7 +524,7 @@
 		*/
 		function get_actual_catalog()
-		{			
+		{
 			$level = $this->bo->get_level_by_branch($this->bo->get_actual_catalog(), $this->bo->tree['branches'], '0');
-			
+
 			if ($level)
 			{
@@ -540,13 +540,13 @@
 			);
 		}
-		
+
 		/*!
-		
+
 			@function get_cards_data
 			@abstract Returns the information that is placed on the cards
 			@author Raphael Derosso Pereira
-			
+
 			@param string $letter The first letter to be searched
-			@param (int)  $page The page to be taken 
+			@param (int)  $page The page to be taken
 			@param (str)  $ids The ids to be taken in case of search
 
@@ -556,12 +556,16 @@
 		function get_cards_data($letter, $page, $ids)
 		{
+
+			// It's an external catalog?
+			$external = $this->bo->is_external($this->page_info['actual_catalog']);
+
 			//echo $page."\n";
 			if ($letter !== 'search' and ($letter != $this->page_info['actual_letter'] or
-			    ($letter == $this->page_info['actual_letter'] and $page == $this->page_info['actual_page']) or 
+			    ($letter == $this->page_info['actual_letter'] and $page == $this->page_info['actual_page']) or
 			    $this->page_info['changed']))
 			{
 				unset($ids);
 				$this->page_info['changed'] = false;
-				 
+
 				switch ($this->page_info['actual_catalog']['class'])
 				{
@@ -650,7 +654,7 @@
 							);
 						}
-						
+
 						$find_field[0] = array('contact.id_contact','contact.names_ordered');
-						
+
 						$find_other[0] = array(
 							//'offset' => (($page-1)*$this->page_info['n_cards']),
@@ -658,7 +662,11 @@
 							'order'  => 'contact.names_ordered'
 						);
-						
+
 						break;
-					
+
+					//case 'bo_external_ldap_catalog':
+
+					//	break;
+
 					case 'bo_global_ldap_catalog':
 						$field_name = 'id_contact';
@@ -671,32 +679,86 @@
 									'type'  => 'iLIKE',
 									'value' => $letter !== 'all' ? $letter.'%' : '%'
-								)
+								),
+								/*
+								 * Restrict the returned contacts in a "first letter" search
+								 * to objectClass = phpgwAccount, must have attibute phpgwAccountStatus,
+								 * phpgwAccountVisible != -1 and objectClass = inetOrgPerson
+								 */
+								1 => array(
+									'field' => 'contact.object_class',
+									'type'  => '=',
+									'value' => 'phpgwAccount'
+								),
+								2 => array(
+									'field' => 'contact.account_status',
+									'type'  => 'iLIKE',
+									'value' => '%'
+								),
+								3 => array(
+									'field' => 'contact.account_visible',
+									'type'  => '!=',
+									'value' => '-1'
+								),
+								4 => array(
+									'field' => 'contact.object_class',
+									'type'  => '=',
+									'value' => 'inetOrgPerson'
+								),
 							);
-							$find_restric[0][1] =  array(
-									'type'  => 'branch',
-									'value' => 'OR',
-									'sub_branch' => array(
-										0 => array(
-										'field' => 'contact.account_type',
-										'type'  => '=',
-										'value' => 'u'
-										),
-										/*1 => array(
-										'field' => 'contact.account_type',
-										'type'  => '=',
-										'value' => 'g'
-										),*/
-										2 => array(
-										'field' => 'contact.account_type',
-										'type'  => '=',
-										'value' => 'l'
+							// If not external catalog get only phpgwAccountType = u ou l
+							if (!$external)
+							{
+								$find_restric[0][5] =  array(
+										'type'  => 'branch',
+										'value' => 'OR',
+										'sub_branch' => array(
+											0 => array(
+											'field' => 'contact.account_type',
+											'type'  => '=',
+											'value' => 'u'
+											),
+											/*1 => array(
+											'field' => 'contact.account_type',
+											'type'  => '=',
+											'value' => 'g'
+											),*/
+											2 => array(
+											'field' => 'contact.account_type',
+											'type'  => '=',
+											'value' => 'l'
+											)
 										)
-									)
-							);
+								);
+							}
 						}
 						else
 						{
 							$find_restric[0] = array(
+								/*
+								 * Restrict the returned contacts in a "first number" search
+								 * to objectClass = phpgwAccount, must have attibute phpgwAccountStatus,
+								 * phpgwAccountVisible != -1 and objectClass = inetOrgPerson
+								 */
 								0 => array(
+									'field' => 'contact.object_class',
+									'type'  => '=',
+									'value' => 'phpgwAccount'
+								),
+								1 => array(
+									'field' => 'contact.account_status',
+									'type'  => 'iLIKE',
+									'value' => '%'
+								),
+								2 => array(
+									'field' => 'contact.account_visible',
+									'type'  => '!=',
+									'value' => '-1'
+								),
+								3 => array(
+									'field' => 'contact.object_class',
+									'type'  => '=',
+									'value' => 'inetOrgPerson'
+								),
+								4 => array(
 									'type'  => 'branch',
 									'value' => 'OR',
@@ -755,29 +817,46 @@
 								),
 							);
-							$find_restric[0][1] =  array(
-								'type'  => 'branch',
-								'value' => 'OR',
-								'sub_branch' => array(
-									0 => array(
-									'field' => 'contact.account_type',
-									'type'  => '=',
-									'value' => 'u'
-									),
-									/*1 => array(
-									'field' => 'contact.account_type',
-									'type'  => '=',
-									'value' => 'g'
-									),*/
-									2 => array(
-									'field' => 'contact.account_type',
-									'type'  => '=',
-									'value' => 'l'
+							// If not external catalog get only phpgwAccountType = u ou l
+							if (!$external)
+							{
+								$find_restric[0][5] =  array(
+									'type'  => 'branch',
+									'value' => 'OR',
+									'sub_branch' => array(
+										0 => array(
+										'field' => 'contact.account_type',
+										'type'  => '=',
+										'value' => 'u'
+										),
+										/*1 => array(
+										'field' => 'contact.account_type',
+										'type'  => '=',
+										'value' => 'g'
+										),*/
+										2 => array(
+										'field' => 'contact.account_type',
+										'type'  => '=',
+										'value' => 'l'
+										)
 									)
-								)
-							);
+								);
+							}
+
 						}
-						
-						$find_field[0] = array('contact.id_contact','contact.names_ordered','contact.account_type');
-						
+
+						if (!$external)
+						{
+							// Get only this attributes: dn, cn, phpgwAccountType, objectClass, phpgwAccountStatus, phpghAccountVisible
+							// for non-external catalogs, used to restrict the attributes used in filters
+							$find_field[0] = array('contact.id_contact','contact.names_ordered','contact.account_type',
+								'contact.object_class','contact.account_status','contact.account_visible');
+						}
+						else
+						{
+							// Get only this attributes: dn, cn for external catalogs,
+							// used to restrict the attributes used in filters
+							$find_field[0] = array('contact.id_contact','contact.names_ordered');
+						}
+
 						$find_other[0] = array(
 							//'offset' => (($page-1)*$this->page_info['n_cards']),
@@ -785,12 +864,12 @@
 							'order'  => 'contact.names_ordered'
 						);
-						
+
 						break;
-					
+
 					case 'bo_company_manager':
 						$field_name = 'id_company';
-	
+
 						$find_field[0] = array('company.id_company','company.company_name');
-						
+
 						$find_other[0] = array(
 							//'offset' => (($page-1)*$this->page_info['n_cards']),
@@ -798,5 +877,5 @@
 							'order'  => 'company.company_name'
 						);
-	
+
 						$find_restric[0] = array(
 							0 => array(
@@ -806,13 +885,13 @@
 							)
 						);
-							
+
 						break;
 
 					case 'bo_group_manager':
-					
+
 						$field_name = 'id_group';
-						
+
 						if ($letter !== 'number')	{
-							
+
 							$find_restric[0] = array(
 								0 => array(
@@ -824,45 +903,45 @@
 						}
 						 else {
-							
+
 							$find_restric[0] = array(
 								0 => array(
 											'field' => 'group.title',
 											'type'  => 'LIKE',
-											'value' => '0%'										
+											'value' => '0%'
 								)
-							);						
+							);
 						}
-						
+
 						array_push($find_restric[0],  array(
 											'field' => 'group.owner',
 											'type'  => '=',
-											'value' => $GLOBALS['phpgw_info']['user']['account_id']										
+											'value' => $GLOBALS['phpgw_info']['user']['account_id']
 								)
 						);
-						
-						$find_field[0] = array('group.id_group','group.title','group.short_name');						
+
+						$find_field[0] = array('group.id_group','group.title','group.short_name');
 						$find_other[0] = array(
 							'order'  => 'group.title'
 						);
-						
+
 						break;
-						
+
 					case 'bo_catalog_group_catalog':
 						$this->page_info['actual_entries'] = false;
-						
+
 						$this->page_info['actual_letter'] = $letter;
 						$this->page_info['actual_page'] = 0;
-						
+
 						$this->save_session();
 						$final[0] = 0;
 						$final[1] = $this -> typeContact;
-						echo serialize($final);						
+						echo serialize($final);
 						return;
 
 				}
-				
+
 				$result = $this->bo->find($find_field[0],$find_restric[0],$find_other[0]);
 				$n_entries = count($result);
-				
+
 				if ($n_entries)
 				{
@@ -878,12 +957,12 @@
 				{
 					$this->page_info['actual_entries'] = false;
-					
+
 					$this->page_info['actual_letter'] = $letter;
 					$this->page_info['actual_page'] = 0;
-					
-					$this->save_session();				
+
+					$this->save_session();
 					$final[0] = 0;
 					$final[1] = $this -> typeContact;
-					echo serialize($final);											
+					echo serialize($final);
 					return;
 				}
@@ -894,25 +973,53 @@
 					{
 						$this->page_info['actual_entries'][] = $value[$field_name];
-					} 
-					//print_r($this->page_info['actual_entries']);
-				}
-			}
+					}
+				}
+			}
+//*************************************************************************
 			else if ($letter === 'search')
 			{
-				if (!$ids and $this->page_info['actual_letter'] !== 'search')
-				{
+				//if (!$ids and $this->page_info['actual_letter'] !== 'search')
+				if (!$ids && !$this->last_search_ids)
+				{
+					error_log('!$ids e $this->page_info[\'actual_letter\'] != search');
 					$this->page_info['actual_entries'] = false;
-					
+
 					$this->page_info['actual_letter'] = $letter;
 					$this->page_info['actual_page'] = 0;
-					
+
 					$this->save_session();
 					$final[0] = 0;
 					$final[1] = $this -> typeContact;
-					echo serialize($final);					
+					echo serialize($final);
 					return;
 				}
-				else if ($ids)
-				{				
+				else if ($ids['error'])
+				{
+					$this->page_info['actual_entries'] = false;
+					$this->page_info['actual_letter'] = $letter;
+					$this->page_info['actual_page'] = 0;
+
+					$this->save_session();
+					$final[0] = 0;
+					$final[1] = $this -> typeContact;
+					$final['error'] = $ids['error'];
+					echo serialize($final);
+					return;
+				}
+				else if ($ids || $this->last_search_ids)
+				{
+
+					if ($ids)
+					{
+
+						$this->last_search_ids = $ids;
+
+					}
+					else {
+
+						$ids = $this->last_search_ids;
+
+					}
+
 					$this->page_info['actual_letter']  = $letter;
 					$this->page_info['actual_entries'] = $ids;
@@ -931,5 +1038,5 @@
 					$page = $this->page_info['n_pages'];
 				}
-				
+
 				$final = array(
 					0 => (int)$this->page_info['n_pages'],
@@ -943,28 +1050,30 @@
 						5 => 'cc_alias',
 						6 => 'cc_id',
-						7 => 'cc_forwarding_address'
+						7 => 'cc_forwarding_address',
+						8 => 'cc_empNumber',
+						9 => 'cc_department'
 					)
 				);
-				
+
 				//echo 'Page: '.$page.'<br>';
 				$id_i = (($page-1)*$this->page_info['n_cards']);
 				$id_f = $id_i + $this->page_info['n_cards'];
 				$n_entries = count($this->page_info['actual_entries']);
-				
+
 				//echo 'ID_I: '.$id_i.'<br>';
 				//echo 'ID_F: '.$id_f.'<br>';
-				///---------------- Correção Temporária PHP5 -----------------------///
+				///---------------- Correï¿œï¿œo Temporï¿œria PHP5 -----------------------///
 				$ids = array();
-				$array_temp = array();			
-								
+				$array_temp = array();
+
 				foreach($this->page_info['actual_entries'] as $key=>$tmp){
-					$array_temp[] = $tmp;				
-				}	
-				
+					$array_temp[] = $tmp;
+				}
+
 				for($i = $id_i; $i < $id_f and $i < $n_entries; $i++)
 				{
 					$ids[] = $array_temp[$i];
 				}
-				
+
 				/// Original
 				//for($i = $id_i; $i < $id_f and $i < $n_entries; $i++)
@@ -973,5 +1082,5 @@
 				//}
 				///
-				
+
 				$fields = $this->bo->catalog->get_fields(false);
 
